unit LichtKrant;
// Auteur: Th.M. Hupkens
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;

type
  TRichting = (NaarLinks, NaarRechts);
  TLichtKrant = class(TLabel)
    private
      Tekst: TCaption;
      FTijdPerStap: integer;
      FRichting: TRichting;
      procedure SetTijdPerStap(const Value: integer);
    public
      Timer: TTimer;
      constructor Create(AOwner: TComponent); override;
      destructor Destroy; override;
      procedure Roteer(Sender: TObject);
      procedure Start;
      procedure Stop(OrigineleTekst: boolean);
    published
      property TijdPerStap: integer read FTijdPerStap write SetTijdPerStap default 100;
      property Richting: TRichting read FRichting write FRichting;
    end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('LevendeVormen', [TLichtKrant]);
end;

{ TLichtKrant }

constructor TLichtKrant.Create(AOwner: TComponent);
begin
  inherited;
  Timer := TTimer.Create(Self);
  Timer.Enabled := false; // Moet default uitstaan
  FTijdPerStap := 100; // Default
  Timer.Interval := FTijdPerStap;
  Timer.OnTimer := Roteer
end;

destructor TLichtKrant.Destroy;
begin
  Timer.Free;
  inherited
end;

procedure TLichtKrant.Roteer;
var Tekst: string;
begin
  Tekst := Text;
  If FRichting = NaarRechts then Begin
     Tekst := Tekst[Length(Tekst)] + Tekst;
     Delete(Tekst, Length(Tekst), 1) End
  else Begin
     Tekst := Tekst + Tekst[1];
     Delete(Tekst, 1, 1) End;
  Text := Tekst
end;

procedure TLichtKrant.SetTijdPerStap(const Value: integer);
begin
  FTijdPerStap := Value; 
  If Value < 0 then // Keer richting om als het TijdPerStap < 0 is
     If FRichting = NaarRechts then FRichting := NaarLinks
     else FRichting := NaarRechts;
  Timer.Interval := abs(Value)
end;

procedure TLichtKrant.Start;
begin
  Tekst := Text;
  Timer.Enabled := true
end;

procedure TLichtKrant.Stop;
begin
  Timer.Enabled := false;
  If OrigineleTekst then Text := Tekst
end;

end.
